import typing
import asyncio

import redpesk_utils.log
import redpesk_utils.common
import redpesk_utils.asyncio_wrapper


class AsyncVirtual:
    def __init__(self, object: typing.Any) -> None:
        self._object = object

    @property
    def object(self) -> typing.Any:
        return self._object

    async def __call__(self, *args: typing.Tuple[typing.Any], **kwargs: typing.Dict[str, typing.Any]) -> typing.Any:
        obj: typing.Any = await asyncio.create_task(asyncio.to_thread(self._object, *args, **kwargs))
        return obj if redpesk_utils.common.IS_BUILTINS(
            obj) else AsyncVirtual(obj)

    def __getattr__(self, name: str) -> typing.Any:
        obj: typing.Any = getattr(self._object, name)
        return obj if redpesk_utils.common.IS_BUILTINS(
            obj) else AsyncVirtual(obj)
