import time
import uuid
import typing
import asyncio

import redpesk_utils.log
import redpesk_utils.error
import redpesk_utils.common


class Request:
    def __init__(
            self,
            ticket: str = str(),
            tic: float = float()) -> None:
        self._tic = tic
        self._ticket = ticket if ticket else str(uuid.uuid4())

    @property
    def ticket(self) -> str:
        return self._ticket

    @property
    def tic(self) -> float:
        return self._tic


def report(tic: float) -> typing.Tuple[str]:
    return (f"{(time.perf_counter() - tic):0.4f}s",)
